<?php

namespace Drupal\entity_value_inheritance;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\entity_value_inheritance\Annotation\EntityValueInheritanceUpdater;

/**
 * A plugin manager for the EntityValueInheritanceUpdater plugins.
 */
class EntityValueInheritanceUpdaterPluginManager extends DefaultPluginManager {

  /**
   * Track of all created instances.
   *
   * @var array
   */
  protected array $instances = [];

  /**
   * Creates the discovery object.
   */
  public function __construct(
    \Traversable $namespaces,
    CacheBackendInterface $cacheBackend,
    ModuleHandlerInterface $moduleHandler,
  ) {
    parent::__construct(
      'Plugin/EntityValueInheritanceUpdater',
      $namespaces,
      $moduleHandler,
      EntityValueInheritanceUpdaterPluginInterface::class,
      EntityValueInheritanceUpdater::class
    );

    $this->alterInfo('entity_value_inheritance_updater_info');

    $this->setCacheBackend($cacheBackend, 'entity_value_inheritance_updater_info', ['entity_value_inheritance_updater_info']);
  }

}
